src/domain/newsitem/dao/DaoNewsItem.java
/**
 * 
 */
package domain.newsitem.dao;

import java.util.ArrayList;
import java.util.Locale;

import domain.newsitem.model.NewsItem;

/**
 * @author beppo
 *
 */
public interface DaoNewsItem {
//	public void insertNewsItem(NewsItem newsItem);
	public void createNewsItem(NewsItem newsItem);
	public NewsItem loadNewsItem(int newsItemId);
	public ArrayList<NewsItem> loadNewsItems(Locale locale);
	public NewsItem editNewsItem(NewsItem newsItem);
	public void deleteNewsItem(int newsItemId);
}

src/domain/newsitem/dao/DaoNewsItemMySQL.java
/**
 * 
 */
package domain.newsitem.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Date;
import java.util.Locale;


import config.MySQLConfig;
import domain.newsitem.model.NewsItem;
import domain.user.dao.UserFacade;
import domain.user.model.User;

/**
 * @author beppo
 *
 */
public class DaoNewsItemMySQL implements DaoNewsItem {

	private MySQLConfig mysqlConfig;
	
	public DaoNewsItemMySQL() {
		mysqlConfig = MySQLConfig.getInstance();	
	}
	
	@Override
	public void createNewsItem(NewsItem newsItem) {
		String sqlQuery = "INSERT INTO news_item (title, body, lang, authorId) " + 
				"VALUES (?, ?, ?, ?); ";
		Connection connection = mysqlConfig.connect();
	    PreparedStatement stm = null;
	    try{
	        stm = connection.prepareStatement(sqlQuery, Statement.RETURN_GENERATED_KEYS);
	        stm.setString(1, newsItem.getTitle());
	        stm.setString(2, newsItem.getBody());
	        stm.setString(3, newsItem.getLang().getLanguage());
	        stm.setInt(4, newsItem.getAuthor().getUserId());
	      
	        if(stm.executeUpdate()>0){
	            // Get the ID
	            try (ResultSet generatedKeys = stm.getGeneratedKeys()) {
	              if (generatedKeys.next()) {
	                  newsItem.setNewsItemId(generatedKeys.getInt(1));
	              }
	              else {
	                  throw new SQLException("Creating user news Item, no ID obtained.");
	              }
	            }
	          }else {
	            throw new SQLException("Creating news Item failed, no rows affected.");
	          }
	      }catch(SQLException e){
	        e.printStackTrace();
	        System.out.println("Error DaoNewsItemMySQL createNewsItem ");
	      }
	}
	
	@Override
	public NewsItem loadNewsItem(int newsItemId) {
		String sqlQuery = "SELECT * FROM news_item WHERE newsItemId=?";
	    NewsItem newsItem = null;
	    Connection connection = mysqlConfig.connect();
	    PreparedStatement stm = null;
	    try{
	      stm = connection.prepareStatement(sqlQuery);
	      stm.setInt(1, newsItemId);
	      System.out.println(stm);
	      ResultSet rs = stm.executeQuery();
	      if(rs.next()){
	    	newsItem = new NewsItem();
	    	fillNewsItem(newsItem, rs);
	      }
	    }catch(SQLException e){
	      e.printStackTrace();
	      System.out.println("Error DaoNewsItemMySQL loadNewsItem");
	    }
	    mysqlConfig.disconnect(connection, stm);
	    return newsItem;
	}

	@Override
	public ArrayList<NewsItem> loadNewsItems(Locale locale) {
		String sqlQuery = "SELECT * FROM news_item WHERE lang =?";
	    Connection connection = mysqlConfig.connect();
	    NewsItem newsItem = null;
	    PreparedStatement stm = null;
	    ArrayList<NewsItem> newsItems = new ArrayList<>();
	    try {
	    	stm = connection.prepareStatement(sqlQuery);
	    	stm.setString(1, locale.getLanguage());
	    	System.out.println(sqlQuery);
	    	ResultSet rs = stm.executeQuery();
	    	while (rs.next()) {
	    		newsItem = new NewsItem();
	    		fillNewsItem(newsItem, rs);
	    		newsItems.add(newsItem);
	    	}
		} catch (SQLException e) {
			e.printStackTrace();
			System.out.println("Error DaoUserMysql loadUsers");
		}
		return newsItems;
	}

	@Override
	public NewsItem editNewsItem(NewsItem NewsItem) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void deleteNewsItem(int NewsItemId) {
		// TODO Auto-generated method stub

	}

	private void fillNewsItem(NewsItem newsItem, ResultSet rs) {
		try {
			newsItem.setNewsItemId(rs.getInt("newsItemId"));
			newsItem.setTitle(rs.getString("title"));
			newsItem.setBody(rs.getString("body"));
			Date date = null;
			date = rs.getDate("date");
			newsItem.setDate(date);
			if(rs.getString("lang") != null) newsItem.setLang(new Locale(rs.getString("lang")));
			else newsItem.setLang(null);
			User user = null;
			UserFacade userfc = new UserFacade();
			user = userfc.loadUser(rs.getInt("authorId"));
			
			newsItem.setAuthor(user);
			
		} catch (SQLException e) {
			e.printStackTrace();
			System.out.println("Error DaoNewsItemMysql fillNewsItem ");
		}
	}

}

src/domain/newsitem/dao/NewsItemFacade.java
package domain.newsitem.dao;

import java.util.ArrayList;
import java.util.Locale;

import domain.newsitem.model.NewsItem;

public class NewsItemFacade {
	DaoNewsItem daoNewsItem = null;
	
	public NewsItemFacade() {
		daoNewsItem = new DaoNewsItemMySQL();
	}

	
	public NewsItem loadNewsItem(int newsItemId) {
		return daoNewsItem.loadNewsItem(newsItemId);
	}
	
	public ArrayList<NewsItem> loadNewsItems(Locale locale) {
		return daoNewsItem.loadNewsItems(locale);
	}
	
	public void createNewsItem(NewsItem newsItem) {
		daoNewsItem.createNewsItem(newsItem);
	}
	
	public NewsItem editNewsItem(NewsItem newsItem) {
		return daoNewsItem.editNewsItem(newsItem);
	}
	
	public void deleteNewsItem(int newsItemId) {
		daoNewsItem.deleteNewsItem(newsItemId);
	}
}

src/domain/newsitem/model/NewsItem.java
/*
 * This is a Java Bean.
 * These are the unique characteristics they must have:
 *     -Default, no-argumented constructor.
 *     -It should be serializable and implement Serializable interface.
 *     -It may have a number of properties which can be read or written.
 *     -"getters" and "setters" for those properties.
 */
package domain.newsitem.model;

import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import domain.user.model.User;

/**
 * @author beppo
 *
 */
public class NewsItem implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7688928851149870938L;
	
	private int newsItemId = 0;
	private String title = null;
	private String body = null;
	private Date date = null;
	private Locale lang = null;
	private User author = null;
	

	public NewsItem() {}
	
	public int getNewsItemId() {
		return newsItemId;
	}

	public void setNewsItemId(int newsItemId) {
		this.newsItemId = newsItemId;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getBody() {
		return body;
	}

	public void setBody(String body) {
		this.body = body;
	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	
	public Locale getLang() {
		return lang;
	}

	public void setLang(Locale lang) {
		this.lang = lang;
	}

	public User getAuthor() {
		return author;
	}

	public void setAuthor(User author) {
		this.author = author;
	}	
	
	public String getDateString() {
		SimpleDateFormat dateFormat = new SimpleDateFormat("dd MMMM yyyy");  
        return dateFormat.format(this.date);  
	}

}

src/controller/NewsItemController.java
package controller;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Locale;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.jstl.core.Config;

import domain.newsitem.dao.NewsItemFacade;
import domain.newsitem.model.NewsItem;
import domain.user.model.User;
import helper.ControllerHelper;

/**
 * Servlet implementation class NewsItem
 */
@WebServlet("/news/*")
public class NewsItemController extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public NewsItemController() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		ControllerHelper controllerHelper = new ControllerHelper(request);
		int newsItemId = controllerHelper.getId();
	    String action = controllerHelper.getAction();
	    
	    switch (action) {
		case "list":
			listNewsItems(request, response);
			break;
		case "create":
			createNewsItemForm(request, response);
			break;
		default:
			break;
		}
	    
//		response.getWriter().append("Served at: ").append(request.getContextPath());
	}
	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		ControllerHelper controllerHelper = new ControllerHelper(request);
		int newsItemId = controllerHelper.getId();
	    String action = controllerHelper.getAction();
	    
	    switch (action) {
		case "create":
			createNewsItem(request, response);
			break;
		default:
			break;
		}
	}


	private void listNewsItems(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		ArrayList<NewsItem> newsItem = null;
		NewsItemFacade nf = new NewsItemFacade();
		Locale lang = getLocale(request, request.getSession());
		newsItem = nf.loadNewsItems(lang);
		
		request.setAttribute("newsItems", newsItem);
		RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/pages/news-item/news_list.jsp");
		dispatcher.forward(request, response);
	}
	
	private void createNewsItemForm(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		request.setAttribute("currentPage", "form");
		RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/pages/news-item/news_form.jsp");
		dispatcher.forward(request, response);
	}
	
	private void createNewsItem(HttpServletRequest request, HttpServletResponse response) throws IOException {
		NewsItemFacade fc = new NewsItemFacade();
		Locale lang = null;
		User user = null;
		HttpSession session = request.getSession(false);
		
		NewsItem newsItem = new NewsItem();
		fillNewsItem(newsItem, request);
		
		lang = getLocale(request, session);
		newsItem.setLang(lang);
		user = (User) session.getAttribute("user");
		newsItem.setAuthor(user);
		
		fc.createNewsItem(newsItem);
		response.sendRedirect(request.getContextPath() + "/news/");
	}

	private void fillNewsItem(NewsItem newsItem, HttpServletRequest request) {
		newsItem.setTitle(request.getParameter("title"));
		newsItem.setBody(request.getParameter("body"));
	}
	
	private Locale getLocale(HttpServletRequest request, HttpSession session) {
		Locale lang = null;
		
		lang = (Locale) Config.get(session, javax.servlet.jsp.jstl.core.Config.FMT_LOCALE);
		if (lang == null) lang = request.getLocale();
		if (lang == null) lang = new Locale("en");
		
		return lang;
	}

}

WebContent/pages/news-item/news_form.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<c:set var="basePath" scope = "page" value="${pageContext.request.contextPath}"/>

<fmt:bundle basename="resources.Resources">
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<c:choose>
	<c:when test="${not empty requestScope.newsItem}">
		<title><fmt:message key="string.title.edit"/></title>
	</c:when>
	<c:otherwise>
		<title><fmt:message key="string.title.create"/></title>
	</c:otherwise>
</c:choose>
<link rel="stylesheet" type="text/css" href="${basePath}/css/style.css">
<link rel="stylesheet" type="text/css" href="${basePath}/css/form.css">
</head>
<body>
<jsp:include page="../../templates/header.jsp"/>
<div class="content">
	<h2><fmt:message key="string.title.form"/></h2>
	<div class="form-container">
		<form action="${not empty requestScope.newsItem ? 'edit' : 'create'}" method="POST">
			<c:choose>
				<c:when test="${not empty requestScope.user}">
					<h2 class="form-title"><fmt:message key="string.title.edit"/></h2>
				</c:when>
				<c:otherwise>
					<h2 class="form-title"><fmt:message key="string.title.create"/></h2>
				</c:otherwise>
			</c:choose>
			
			<label for="title"><fmt:message key="string.newsItem.title"/></label>
			<input type="text" name="title" value="${not empty requestScope.newsItem ? requestScope.newsItem.title : ''}"/>
			<label for="body"><fmt:message key="string.newsItem.body"/></label>
			<textarea name="body">${not empty requestScope.newsItem ? requestScope.newsItem.body : ''}</textarea>
			<c:choose>
				<c:when test="${not empty requestScope.newsItem}">
					<button type="submit" ><fmt:message key="string.button.edit"/></button>
				</c:when>
				<c:otherwise>
					<button type="submit" ><fmt:message key="string.button.create"/></button>
				</c:otherwise>
			</c:choose>
		</form>
	</div>
</div>
</fmt:bundle>
<jsp:include page="../../templates/footer.jsp"/>

WebContent/pages/news-item/news_list.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri = "http://java.sun.com/jsp/jstl/functions" prefix = "fn" %>
<fmt:bundle basename="resources.Resources">
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title><fmt:message key="string.title.list"/></title>
<link rel="stylesheet" type="text/css" href="${pageContext.request.contextPath}/css/style.css">
<link rel="stylesheet" type="text/css" href="${pageContext.request.contextPath}/css/news-list.css">
</head>
<body>
<jsp:include page="../../templates/header.jsp"/>
<div class="content">
	<!-- <h2><fmt:message key="string.title.list"/></h2> -->
	<div class="container">
		<c:forEach items="${requestScope.newsItems}" var="newsItem" >
			<article class="news-item">
				<div class="news-header">
			    	<h2>${newsItem.title}</h2>
			  	</div>
			  	<div class="news-content">
			  		<p>${newsItem.body}</p>
			  	</div>
			  	<div class="news-footer">
			  		<span class="news-user">User: <a href="">${newsItem.author.username}</a></span>
			  		<span class="news-lang">${newsItem.lang}</span>
			  		<span class="news-date">${newsItem.dateString}</span>
			  	</div>
			</article>
		</c:forEach>
	</div>
</div>
</fmt:bundle>
<jsp:include page="../../templates/footer.jsp"/>